//OUT widgets.out
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * Homework 3 Draft sample solution
 * 
 * CS 46B Introduction to Data Structures
 * San Jose State University
 * Summer 2015
 * Instructor: Ron Mak
 * 
 * @author rmak
 */
public class Widgets2
{
    private static final String INPUT_FILE_NAME = "widgets.csv";
    private static final String REPORT_NAME     = "widgets.out";
    
    private Scanner     in;
    private PrintWriter out;
    
    // Column headers
    private String stateHdr, plantHdr, deptHdr, empIdHdr, nameHdr, countHdr;
    
    /**
     * Read the column headers from the first input line and print them.
     */
    private void doColumnHeaders()
    {
        in.useDelimiter("[\r,]");
        
        // Scan the first input line for the column headers.
        stateHdr = in.next();
        plantHdr = in.next();
        deptHdr  = in.next();
        empIdHdr = in.next();
        nameHdr  = in.next();
        countHdr = in.next();
        
        // Print the headers.
        out.printf("%s %s %s %s %s %s\n\n",
                   stateHdr, plantHdr, deptHdr, 
                   empIdHdr, countHdr, nameHdr);
    }
    
    /**
     * Print the lines of the detail report.
     */
    private void doDetailRecords()
    {
        // Values read from a detail record.
        int stateCode, plantCode, deptCode, id, count;
        String name;
        
        in.useDelimiter("[\r,]");
        
        // Loop over the input detail records.
        do {
            in.nextLine();
            
            // Read each field of a detail record.
            stateCode = in.nextInt();
            plantCode = in.nextInt();
            deptCode  = in.nextInt();
            id        = in.nextInt();
            name      = in.next();
            count     = in.nextInt();
            
            // Print a detail line.
            out.printf("%5d %5d %4d %5d %5d %s\n",
                       stateCode, plantCode, deptCode, id, count, name);
        } while (in.hasNextLine());
    }
    
    /**
     * Generate a widget detail report.
     */
    private void generateReport()
    {
        doColumnHeaders();
        doDetailRecords();
    }
    
    /**
     * Initialize the input and output before generating a report.
     */
    private void initialize(String inputFileName, String outputFileName)
    {
        try {
            in  = new Scanner(new File(inputFileName));
            //out = new PrintWriter(outputFileName);
            out = new PrintWriter(System.out);
            
            generateReport();
        }
        catch (FileNotFoundException ex) {
            System.out.println("*** ERROR: File not found: " + inputFileName);
        }
        finally {
            if (in  != null) in.close();
            if (out != null) out.close();
        }
    }
    
    /**
     * The main.
     * @param args the command-line parameters
     */
    public static void main(String args[])
    {
        Widgets2 widgets = new Widgets2();
        widgets.initialize(INPUT_FILE_NAME, REPORT_NAME);
    }
}
